﻿package Specific
{
	import flash.display.MovieClip;
	import flash.events.MouseEvent;
	
	import com.indindi.StateMachine.*;
	
	public class DeadState extends IState
	{
		
		/* 
		Pour pouvoir utiliser facilement les évènements sur l'état
		on garde un pointeur sur le movieClip (_root/Stage) qui est
		récupéré à la création
		*/
		private var PMC:MovieClip = new MovieClip();
		
		/*
		Par commodité, on garde un pointeur sur la machine à état dont
		fait partie l'étt actuel qu'on récupère à la création.
		*/
		private var MySM:StateMachine = new StateMachine();
		
		private var counter:int;
		private var duration:int;
		
		static const REAPPEARING_DURATION = 10000;
		
		public function DeadState(SM:StateMachine,ParentMC:MovieClip,stateName:String):void
		{
			super(stateName);
			PMC = ParentMC;			
			MySM = SM;
		}
		
		
		/*
		Ces trois fonctions sont gérées au niveau de la StateMachine
		et doivent figurer dans la classe dérivée.
		*/
		override public function Enter():void
		{	
			counter = 0;
			duration = 0;
			
			PMC.getPlayerObj().lives--;
			
			if (PMC.getPlayerObj().lives == 0) {
				trace("YOU LOSE !!!!!!!!!!!!!!!!!");
				PMC.getStateMachine().GotoNextState();
			}

			PMC.resetPlayer();

//			trace("Entree player alive");
//			Introfond = new GfxIntro();
//			Introfond.x = 150;
//			Introfond.y = 50;
//			PMC.addChild(Introfond);
//			
//			PMC.stage.addEventListener(MouseEvent.CLICK,GoGame);
		}
		
		override public function Exit():void
		{
//			PMC.removeChild(Introfond);			
//
//			PMC.stage.removeEventListener(MouseEvent.CLICK,GoGame);
		}
		
		override public function Update(time:int):void
		{
			// Clignotate player
				
			if (duration > 100) {
				PMC.drawRing();
				if (counter < 10) {
					PMC.drawPlayer();
					PMC.playDeadStateSound();
				} else {
					if (counter > 20) {
						counter = 0;
					}
				}
				
				if (duration > 200) {
					MySM.GotoPreviousState();
				}
				counter++;
			}
			duration++;
		}
	}
}